Index: LMDZ6/trunk/libf/misc/readTracFiles_mod.f90
===================================================================
--- LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 5184)
+++ LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 5190)
@@ -10,9 +10,9 @@
 
   PUBLIC :: maxlen                                              !--- PARAMETER FOR CASUAL STRING LENGTH
-  PUBLIC :: keys_type, tracers, setGeneration, indexUpdate      !--- TRACERS  DESCRIPTION DATABASE + ASSOCIATED TOOLS
+  PUBLIC :: trac_type, tracers, setGeneration, indexUpdate      !--- TRACERS  DESCRIPTION DATABASE + ASSOCIATED TOOLS
   PUBLIC :: testTracersFiles, readTracersFiles                  !--- TRACERS FILES READING ROUTINES
   PUBLIC :: getKeysDBase, setKeysDBase                          !--- TOOLS TO GET/SET THE DATABASE (tracers & isotopes)
   PUBLIC :: addTracer, delTracer                                !--- ADD/REMOVE A TRACER FROM
-  PUBLIC :: addKey,    delKey,    getKey                        !--- TOOLS TO SET/DEL/GET KEYS FROM/TO  tracers & isotopes
+  PUBLIC :: addKey,    delKey,    getKey,    keys_type          !--- TOOLS TO SET/DEL/GET KEYS FROM/TO  tracers & isotopes
   PUBLIC :: addPhase,  delPhase,  getPhase,  getiPhase,  &      !--- FUNCTIONS RELATED TO THE PHASES
    nphases, old_phases, phases_sep, known_phases, phases_names  !--- + ASSOCIATED VARIABLES
@@ -35,5 +35,5 @@
   PUBLIC :: itZonIso                                            !--- Idx IN isoName(1:niso) = f(tagging idx, isotope idx)
   PUBLIC :: iqIsoPha                                            !--- Idx IN qx(1:nqtot)     = f(isotope idx,   phase idx)
-  PUBLIC :: iqWIsoPha                                           !--- SAME AS iqIsoPha BUT ISOTOPES LIST STARTS WITH PARENT TRAC
+  PUBLIC :: iqWIsoPha                                           !--- Idx IN qx(1:nqtot)     = f(isotope idx,   phase idx) but with normal water first
   PUBLIC :: isoCheck                                            !--- FLAG TO RUN ISOTOPES CHECKING ROUTINES
 
@@ -41,10 +41,34 @@
 !------------------------------------------------------------------------------------------------------------------------------
   TYPE :: keys_type                                             !=== TYPE FOR A SET OF KEYS ASSOCIATED TO AN ELEMENT
+    CHARACTER(LEN=maxlen)              :: name                  !--- Tracer name
     CHARACTER(LEN=maxlen), ALLOCATABLE :: key(:)                !--- Keys string list
     CHARACTER(LEN=maxlen), ALLOCATABLE :: val(:)                !--- Corresponding values string list
   END TYPE keys_type
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE :: isot_type                                             !=== TYPE FOR AN ISOTOPES FAMILY DESCENDING ON TRACER "name"
-    CHARACTER(LEN=maxlen)              :: name                  !--- Isotopes family name (example: H2O)
+  TYPE :: trac_type                                             !=== TYPE FOR A SINGLE TRACER NAMED "name"
+    CHARACTER(LEN=maxlen) :: name        = ''                   !--- Name of the tracer
+    TYPE(keys_type)       :: keys                               !--- <key>=<val> pairs vector
+    CHARACTER(LEN=maxlen) :: gen0Name    = ''                   !--- First generation ancestor name
+    CHARACTER(LEN=maxlen) :: parent      = ''                   !--- Parent name
+    CHARACTER(LEN=maxlen) :: longName    = ''                   !--- Long name (with advection scheme suffix)
+    CHARACTER(LEN=maxlen) :: type        = 'tracer'             !--- Type  (so far: 'tracer' / 'tag')
+    CHARACTER(LEN=maxlen) :: phase       = 'g'                  !--- Phase ('g'as / 'l'iquid / 's'olid)
+    CHARACTER(LEN=maxlen) :: component   = ''                   !--- Coma-separated list of components (Ex: lmdz,inca)
+    INTEGER               :: iGeneration = -1                   !--- Generation number (>=0)
+    INTEGER               :: iqParent    = 0                    !--- Parent index
+    INTEGER,  ALLOCATABLE :: iqDescen(:)                        !--- Descendants index (in growing generation order)
+    INTEGER               :: nqDescen    = 0                    !--- Number of descendants (all generations)
+    INTEGER               :: nqChildren  = 0                    !--- Number of children  (first generation)
+    INTEGER               :: iadv        = 10                   !--- Advection scheme used
+    LOGICAL               :: isAdvected  = .FALSE.              !--- "true" tracers: iadv > 0.   COUNT(isAdvected )=nqtrue
+    LOGICAL               :: isInPhysics = .TRUE.               !--- "true" tracers: in tr_seri. COUNT(isInPhysics)=nqtottr
+    INTEGER               :: iso_iGroup  = 0                    !--- Isotopes group index in isotopes(:)
+    INTEGER               :: iso_iName   = 0                    !--- Isotope  name  index in isotopes(iso_iGroup)%trac(:)
+    INTEGER               :: iso_iZone   = 0                    !--- Isotope  zone  index in isotopes(iso_iGroup)%zone(:)
+    INTEGER               :: iso_iPhase  = 0                    !--- Isotope  phase index in isotopes(iso_iGroup)%phase
+  END TYPE trac_type
+!------------------------------------------------------------------------------------------------------------------------------
+  TYPE :: isot_type                                             !=== TYPE FOR AN ISOTOPES FAMILY DESCENDING ON TRACER "parent"
+    CHARACTER(LEN=maxlen)              :: parent                !--- Isotopes family name (parent tracer name ; ex: H2O)
     TYPE(keys_type),       ALLOCATABLE :: keys(:)               !--- Isotopes keys/values pairs list     (length: niso)
     LOGICAL                            :: check=.FALSE.         !--- Flag for checking routines triggering
@@ -64,5 +88,5 @@
   TYPE :: dataBase_type                                         !=== TYPE FOR TRACERS SECTION
     CHARACTER(LEN=maxlen) :: name                               !--- Section name
-    TYPE(keys_type), ALLOCATABLE :: trac(:)                     !--- Tracers descriptors
+    TYPE(trac_type), ALLOCATABLE :: trac(:)                     !--- Tracers descriptors
   END TYPE dataBase_type
 !------------------------------------------------------------------------------------------------------------------------------
@@ -115,5 +139,5 @@
 
   !=== TRACERS AND ISOTOPES DESCRIPTORS, USED BY getKey
-  TYPE(keys_type), ALLOCATABLE, TARGET, SAVE ::  tracers(:)
+  TYPE(trac_type), ALLOCATABLE, TARGET, SAVE ::  tracers(:)
   TYPE(isot_type), ALLOCATABLE, TARGET, SAVE :: isotopes(:)
 
@@ -169,8 +193,8 @@
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=*),                               INTENT(IN)  :: type_trac     !--- List of components used
-  TYPE(keys_type), ALLOCATABLE, TARGET, OPTIONAL, INTENT(OUT) :: tracs(:)      !--- Tracers descriptor for external storage
+  TYPE(trac_type), ALLOCATABLE, TARGET, OPTIONAL, INTENT(OUT) :: tracs(:)      !--- Tracers descriptor for external storage
   LOGICAL,                              OPTIONAL, INTENT(IN)  :: lRepr         !--- Activate the HNO3 exceptions for REPROBUS
   CHARACTER(LEN=maxlen),  ALLOCATABLE :: s(:), sections(:), trac_files(:)
-  CHARACTER(LEN=maxlen) :: str, fname, tname, pname, cname, ttype
+  CHARACTER(LEN=maxlen) :: str, fname, tname, pname, cname
   INTEGER               :: nsec, ierr, it, ntrac, ns, ip, ix, fType
   INTEGER, ALLOCATABLE  :: iGen(:)
@@ -208,5 +232,5 @@
         CALL msg('This file is for air tracers only',           modname, ns == 3 .AND. it == 1)
         CALL msg('This files specifies the transporting fluid', modname, ns == 4 .AND. it == 1)
-        k => tracers(it)
+        k => tracers(it)%keys
 
         !=== NAME OF THE TRACER
@@ -214,11 +238,13 @@
         ix = strIdx(oldHNO3, s(3))
         IF(ix /= 0 .AND. lRep) tname = newHNO3(ix)                   !--- Exception for HNO3 (REPROBUS ONLY)
-        CALL addKey('name', tname, tracers)                          !--- Set the name of the tracer
-!        tracers(it)%name = tname                                     !--- Copy tracers names in keys components
+        tracers(it)%name = tname                                     !--- Set the name of the tracer
+        CALL addKey('name', tname, k)                                !--- Set the name of the tracer
+        tracers(it)%keys%name = tname                                !--- Copy tracers names in keys components
 
         !=== NAME OF THE COMPONENT
         cname = type_trac                                            !--- Name of the model component
         IF(ANY([(addPhase('H2O', ip), ip = 1, nphases)] == tname)) cname = 'lmdz'
-        CALL addKey('component', cname, tracers)                     !--- Set the name of the model component
+        tracers(it)%component = cname                                !--- Set component
+        CALL addKey('component', cname, k)                           !--- Set the name of the model component
 
         !=== NAME OF THE PARENT
@@ -229,8 +255,10 @@
           IF(ix /= 0 .AND. lRep) pname = newHNO3(ix)                 !--- Exception for HNO3 (REPROBUS ONLY)
         END IF
-        CALL addKey('parent', pname, tracers)                        !--- Set the parent name
+        tracers(it)%parent = pname                                   !--- Set the parent name
+        CALL addKey('parent', pname, k)
 
         !=== PHASE AND ADVECTION SCHEMES NUMBERS
-        CALL addKey('phase', known_phases(ip:ip), tracers)           !--- Set the phase of the tracer (default: "g"azeous)
+        tracers(it)%phase = known_phases(ip:ip)                      !--- Set the phase of the tracer (default: "g"azeous)
+        CALL addKey('phase', known_phases(ip:ip), k)                 !--- Set the phase of the tracer (default: "g"azeous)
         CALL addKey('hadv', s(1),  k)                                !--- Set the horizontal advection schemes number
         CALL addKey('vadv', s(2),  k)                                !--- Set the vertical   advection schemes number
@@ -238,8 +266,8 @@
       CLOSE(90)
       lerr = setGeneration(tracers); IF(lerr) RETURN                 !--- Set iGeneration and gen0Name
-      lerr = getKey('iGeneration', iGen, tracers(:))                 !--- Generation number
+      lerr = getKey('iGeneration', iGen, tracers(:)%keys)            !--- Generation number
+      WHERE(iGen == 2) tracers(:)%type = 'tag'                       !--- Set type:      'tracer' or 'tag'
       DO it = 1, ntrac
-        ttype = 'tracer'; IF(iGen(it) == 2) ttype = 'tag'
-        CALL addKey('type', ttype, tracers(it))                 !--- Set the type of tracer
+        CALL addKey('type', tracers(it)%type, tracers(it)%keys)      !--- Set the type of tracer
       END DO
       lerr = checkTracers(tracers, fname, fname); IF(lerr) RETURN    !--- Detect orphans and check phases
@@ -263,5 +291,5 @@
   END IF
   lerr = indexUpdate(tracers); IF(lerr) RETURN                       !--- Set iqParent, iqDescen, nqDescen, nqChildren
-  IF(PRESENT(tracs)) tracs = tracers
+  IF(PRESENT(tracs)) CALL MOVE_ALLOC(FROM=tracers, TO=tracs)
 END FUNCTION readTracersFiles
 !==============================================================================================================================
@@ -311,8 +339,8 @@
 ! Purpose: Read the sections "snames(is)" (pipe-separated list) from each "fnames(is)"
 !   file and create the corresponding tracers set descriptors in the database "dBase":
-! * dBase(id)%name           : section name
-! * dBase(id)%trac(:)        : tracers descriptor (the key "name" of tracers(i) is the name of the ith tracer)
-! * dBase(id)%trac(it)%key(:): names  of keys associated to tracer dBase(id)%trac(it)%name
-! * dBase(id)%trac(it)%val(:): values of keys associated to tracer dBase(id)%trac(it)%name
+! * dBase(id)%name                : section name
+! * dBase(id)%trac(:)%name        : tracers names
+! * dBase(id)%trac(it)%keys%key(:): names  of keys associated to tracer dBase(id)%trac(it)%name
+! * dBase(id)%trac(it)%keys%val(:): values of keys associated to tracer dBase(id)%trac(it)%name
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=*), INTENT(IN)  :: fnames(:)                         !--- Files names
@@ -367,7 +395,5 @@
   ndb= SIZE(dBase)                                                   !--- Current number of sections in the database
   IF(PRESENT(defName)) THEN                                          !--- Add default values to all the tracers
-    DO idb=n0,ndb                                                    !--- and remove the virtual tracer "defName"
-       lerr = addDefault(dBase(idb)%trac, defName); IF(lerr) RETURN
-    END DO
+    DO idb=n0,ndb; CALL addDefault(dBase(idb)%trac, defName); END DO !--- and remove the virtual tracer "defName"
   END IF
   ll = strParse(snam, '|', keys = sec)                               !--- Requested sections names
@@ -382,5 +408,6 @@
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen), ALLOCATABLE ::  s(:), v(:)
-  TYPE(keys_type),       ALLOCATABLE :: tt(:)
+  TYPE(trac_type),       ALLOCATABLE :: tt(:)
+  TYPE(trac_type)       :: tmp
   CHARACTER(LEN=1024)   :: str, str2
   CHARACTER(LEN=maxlen) :: secn
@@ -418,6 +445,7 @@
       tt = dBase(ndb)%trac(:)
       v(1) = s(1); s(1) = 'name'                                     !--- Convert "name" into a regular key
-      dBase(ndb)%trac = [tt(:), keys_type(s(:), v(:))]
-      DEALLOCATE(tt)
+      tmp%name = v(1); tmp%keys = keys_type(v(1), s(:), v(:))        !--- Set %name and %keys
+      dBase(ndb)%trac = [tt(:), tmp]
+      DEALLOCATE(tt, tmp%keys%key, tmp%keys%val)
     END IF
   END DO
@@ -432,51 +460,52 @@
 
 !==============================================================================================================================
-LOGICAL FUNCTION addDefault(t, defName) RESULT(lerr)
+SUBROUTINE addDefault(t, defName)
 !------------------------------------------------------------------------------------------------------------------------------
 ! Purpose: Add the keys from virtual tracer named "defName" (if any) and remove this virtual tracer.
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: t(:)
+  TYPE(trac_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: t(:)
   CHARACTER(LEN=*),                     INTENT(IN)    :: defName
   INTEGER :: jd, it, k
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:)
-  TYPE(keys_type),       ALLOCATABLE :: tt(:)
-  lerr = getKey('name', tname, t(:)); IF(lerr) RETURN
-  jd = strIdx(tname(:), defName)
+  TYPE(keys_type), POINTER :: ky
+  TYPE(trac_type), ALLOCATABLE :: tt(:)
+  jd = strIdx(t(:)%name, defName)
   IF(jd == 0) RETURN
-  DO k = 1, SIZE(t(jd)%key)                                          !--- Loop on the keys of the tracer named "defName"
-!   CALL addKey(t(jd)%key(k), t(jd)%val(k), t(:), .FALSE.)           !--- Add key to all the tracers (no overwriting)
-    DO it = 1, SIZE(t); CALL addKey(t(jd)%key(k), t(jd)%val(k), t(it), .FALSE.); END DO
+  ky => t(jd)%keys
+  DO k = 1, SIZE(ky%key)                                             !--- Loop on the keys of the tracer named "defName"
+!   CALL addKey(ky%key(k), ky%val(k), t(:)%keys, .FALSE.)            !--- Add key to all the tracers (no overwriting)
+    DO it = 1, SIZE(t); CALL addKey(ky%key(k), ky%val(k), t(it)%keys, .FALSE.); END DO
   END DO
   tt = [t(1:jd-1),t(jd+1:SIZE(t))]; CALL MOVE_ALLOC(FROM=tt, TO=t)   !--- Remove the virtual tracer named "defName"
-END FUNCTION addDefault
-!==============================================================================================================================
-
-!==============================================================================================================================
-LOGICAL FUNCTION subDefault(t, defName, lSubLocal) RESULT(lerr)
+END SUBROUTINE addDefault
+!==============================================================================================================================
+
+!==============================================================================================================================
+SUBROUTINE subDefault(t, defName, lSubLocal)
 !------------------------------------------------------------------------------------------------------------------------------
 ! Purpose: Substitute the keys from virtual tracer named "defName" (if any) and remove this virtual tracer.
 !          Substitute the keys locally (for the current tracer) if the flag "lSubLocal" is .TRUE.
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: t(:)
+  TYPE(trac_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: t(:)
   CHARACTER(LEN=*),                     INTENT(IN)    :: defName
   LOGICAL,                              INTENT(IN)    :: lSubLocal
   INTEGER :: i0, it, ik
-  TYPE(keys_type),       ALLOCATABLE :: tt(:)
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:)
-  lerr = getKey('name', tname, t(:)); IF(lerr) RETURN
-  i0 = strIdx(tname(:), defName)
+  TYPE(keys_type), POINTER     :: k0, ky
+  TYPE(trac_type), ALLOCATABLE :: tt(:)
+  i0 = strIdx(t(:)%name, defName)
   IF(i0 == 0) RETURN
+  k0 => t(i0)%keys 
   DO it = 1, SIZE(t); IF(it == i0) CYCLE                             !--- Loop on the tracers
+    ky => t(it)%keys
 
     !--- Substitute in the values of <key>=<val> pairs the keys defined in the virtual tracer "defName"
-    DO ik = 1, SIZE(t(i0)%key); CALL strReplace(t(it)%val, t(i0)%key(ik), t(i0)%val(ik), .TRUE.); END DO
+    DO ik = 1, SIZE(k0%key); CALL strReplace(ky%val, k0%key(ik), k0%val(ik), .TRUE.); END DO
 
     IF(.NOT.lSubLocal) CYCLE
     !--- Substitute in the values of <key>=<val> pairs the keys defined locally (in the current tracer)
-    DO ik = 1, SIZE(t(it)%key); CALL strReplace(t(it)%val, t(it)%key(ik), t(it)%val(ik), .TRUE.); END DO
+    DO ik = 1, SIZE(ky%key); CALL strReplace(ky%val, ky%key(ik), ky%val(ik), .TRUE.); END DO
   END DO
   tt = [t(1:i0-1),t(i0+1:SIZE(t))]; CALL MOVE_ALLOC(FROM=tt, TO=t)   !--- Remove the virtual tracer named "defName"
 
-END FUNCTION subDefault
+END SUBROUTINE subDefault
 !==============================================================================================================================
 
@@ -489,8 +518,8 @@
 !        * Default values are provided for these keys because they are necessary.
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)                 !--- Tracer derived type vector
+  TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)                 !--- Tracer derived type vector
   CHARACTER(LEN=*),             INTENT(IN)    :: sname                 !--- Current section name
   CHARACTER(LEN=*), OPTIONAL,   INTENT(IN)    :: fname                 !--- Tracers description file name
-  TYPE(keys_type),       ALLOCATABLE :: ttr(:)
+  TYPE(trac_type),       ALLOCATABLE :: ttr(:)
   CHARACTER(LEN=maxlen), ALLOCATABLE :: ta(:), pa(:), tname(:), parent(:), dType(:)
   CHARACTER(LEN=maxlen) :: msg1, modname
@@ -500,7 +529,7 @@
   lerr = .FALSE.
   nt = SIZE(tr)
-  lerr = getKey('name',   tname,  tr(:));                 IF(lerr) RETURN
-  lerr = getKey('parent', parent, tr(:), def = tran0);    IF(lerr) RETURN
-  lerr = getKey('type',   dType,  tr(:), def = 'tracer'); IF(lerr) RETURN
+  lerr = getKey('name',   tname,  tr(:)%keys);                 IF(lerr) RETURN
+  lerr = getKey('parent', parent, tr(:)%keys, def = tran0);    IF(lerr) RETURN
+  lerr = getKey('type',   dType,  tr(:)%keys, def = 'tracer'); IF(lerr) RETURN
   nq = 0
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -508,5 +537,6 @@
   !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
     !--- Extract useful keys: parent name, type, component name
-    CALL addKey('component', sname,  tr(it))
+    tr(it)%component = sname
+    CALL addKey('component', sname,  tr(it)%keys)
 
     !--- Determine the number of tracers and parents ; coherence checking
@@ -535,10 +565,15 @@
     DO ipr = 1, npr                                                  !--- Loop on parents list elts
       DO itr = 1, ntr                                                !--- Loop on tracers list elts
-        ttr(iq)%key  = tr(it)%key
-        ttr(iq)%val  = tr(it)%val
-        CALL addKey('name',    ta(itr), ttr(iq))
-        CALL addKey('parent',  pa(ipr), ttr(iq))
-        CALL addKey('type',  dType(it), ttr(iq))
-        CALL addKey('component', sname, ttr(iq))
+        ttr(iq)%keys%name = TRIM(ta(itr))
+        ttr(iq)%keys%key  = tr(it)%keys%key
+        ttr(iq)%keys%val  = tr(it)%keys%val
+        ttr(iq)%name      = TRIM(ta(itr))
+        ttr(iq)%parent    = TRIM(pa(ipr))
+        ttr(iq)%type      = dType(it)
+        ttr(iq)%component = sname
+        CALL addKey('name',      ta(itr),   ttr(iq)%keys)
+        CALL addKey('parent',    pa(ipr),   ttr(iq)%keys)
+        CALL addKey('type',      dType(it), ttr(iq)%keys)
+        CALL addKey('component', sname,     ttr(iq)%keys)
         iq = iq + 1
       END DO
@@ -562,5 +597,5 @@
 !          Check also for orphan tracers (tracers without parent).
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type),     INTENT(INOUT) :: tr(:)                        !--- Tracer derived type vector
+  TYPE(trac_type),     INTENT(INOUT) :: tr(:)                        !--- Tracer derived type vector
   INTEGER                            :: iq, jq, ig
   CHARACTER(LEN=maxlen), ALLOCATABLE :: parent(:), tname(:)
@@ -568,6 +603,6 @@
   CHARACTER(LEN=maxlen) :: modname
   modname = 'setGeneration'
-  lerr = getKey('name',   tname,  ky=tr(:)); IF(lerr) RETURN
-  lerr = getKey('parent', parent, ky=tr(:)); IF(lerr) RETURN
+  lerr = getKey('name',   tname,  ky=tr(:)%keys); IF(lerr) RETURN
+  lerr = getKey('parent', parent, ky=tr(:)%keys); IF(lerr) RETURN
   DO iq = 1, SIZE(tr)
     jq = iq; ig = 0
@@ -578,6 +613,8 @@
       ig = ig + 1
     END DO
-    CALL addKey('iGeneration',    ig,  tr(iq))
-    CALL addKey('gen0Name', tname(jq), tr(iq))
+    tr(iq)%gen0Name = tname(jq)
+    tr(iq)%iGeneration = ig
+    CALL addKey('iGeneration',   ig,  tr(iq)%keys)
+    CALL addKey('gen0Name', tname(jq), tr(iq)%keys)
   END DO
 END FUNCTION setGeneration
@@ -592,5 +629,5 @@
 !   * check wether the phases are known or not (elements of "known_phases")
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type),            INTENT(IN) :: tr(:)                    !--- Tracers description vector
+  TYPE(trac_type),            INTENT(IN) :: tr(:)                    !--- Tracer derived type vector
   CHARACTER(LEN=*),           INTENT(IN) :: sname                    !--- Section name
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fname                    !--- File name
@@ -607,6 +644,6 @@
   mesg = 'Check section "'//TRIM(sname)//'"'
   IF(PRESENT(fname)) mesg=TRIM(mesg)//' in file "'//TRIM(fname)//'"'
-  lerr = getKey('iGeneration', iGen, tr(:));                    IF(lerr) RETURN
-  lerr = getKey('name',       tname, tr(:));                    IF(lerr) RETURN
+  lerr = getKey('iGeneration', iGen, tr(:)%keys);               IF(lerr) RETURN
+  lerr = getKey('name',       tname, tr(:)%keys);               IF(lerr) RETURN
 
   !=== CHECK FOR ORPHAN TRACERS
@@ -615,5 +652,5 @@
   !=== CHECK PHASES
   DO iq = 1, nq; IF(iGen(iq) /= 0) CYCLE                             !--- Generation O only is checked
-    IF(getKey(['phases','phase '], pha, iq, tr(:), lDisp=.FALSE.)) pha = 'g'   !--- Phase
+    IF(getKey(['phases','phase '], pha, iq, tr(:)%keys, lDisp=.FALSE.)) pha = 'g'   !--- Phase
     np = LEN_TRIM(pha); bp(iq)=' '
     DO ip = 1, np; p = pha(ip:ip); IF(INDEX(known_phases, p) == 0) bp(iq) = TRIM(bp(iq))//p; END DO
@@ -630,5 +667,5 @@
 ! Purpose: Make sure that tracers are not repeated.
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type),            INTENT(IN) :: tr(:)                    !--- Tracers description vector
+  TYPE(trac_type),            INTENT(IN) :: tr(:)                    !--- Tracer derived type vector
   CHARACTER(LEN=*),           INTENT(IN) :: sname                    !--- Section name
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fname                    !--- File name
@@ -647,7 +684,7 @@
   nq=SIZE(tr,DIM=1); lerr=.FALSE.                                    !--- Number of lines ; error flag
   tdup(:) = ''
-  lerr = getKey('name',       tname, tr); IF(lerr) RETURN
-  lerr = getKey('type',       dType, tr); IF(lerr) RETURN
-  lerr = getKey('iGeneration', iGen, tr); IF(lerr) RETURN
+  lerr = getKey('name',       tname, tr%keys); IF(lerr) RETURN
+  lerr = getKey('type',       dType, tr%keys); IF(lerr) RETURN
+  lerr = getKey('iGeneration', iGen, tr%keys); IF(lerr) RETURN
   DO iq = 1, nq
     IF(dType(iq) == 'tag') CYCLE                                     !--- Tags can be repeated
@@ -661,5 +698,5 @@
         DO k = 1, nq
           IF(.NOT.ll(k)) CYCLE                                       !--- Skip tracers different from current one
-          IF(getKey(['phases','phase '], phase, k, tr, lDisp=.FALSE.)) phase='g'!--- Get current phases
+          IF(getKey(['phases','phase '], phase, k, tr%keys, lDisp=.FALSE.)) phase='g'!--- Get current phases
           IF(INDEX(phase, p) /= 0) np = np + 1                       !--- One more appearance of current tracer with phase "p"
         END DO
@@ -681,7 +718,7 @@
 ! Purpose: Expand the phases in the tracers descriptor "tr". Phases are not repeated for a tracer, thanks to "checkUnique".
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)               !--- Tracers description vector
-!------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type),       ALLOCATABLE :: ttr(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tr(:)               !--- Tracer derived type vector
+!------------------------------------------------------------------------------------------------------------------------------
+  TYPE(trac_type),       ALLOCATABLE :: ttr(:)
   INTEGER,               ALLOCATABLE ::  i0(:), iGen(:)
   CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:), gen0N(:), phase(:), parents(:), dType(:)
@@ -695,10 +732,10 @@
   nq = SIZE(tr, DIM=1)
   nt = 0
-  lerr = getKey('name',       tname, tr); IF(lerr) RETURN            !--- Names of the tracers
-  lerr = getKey('gen0Name',   gen0N, tr); IF(lerr) RETURN            !--- Names of the tracers of first generation
-  lerr = getKey('iGeneration', iGen, tr); IF(lerr) RETURN            !--- Generation number
-  lerr = getKey('phases',     phase, tr); IF(lerr) RETURN            !--- Phases names
-  lerr = getKey('parent',   parents, tr); IF(lerr) RETURN            !--- Parents names
-  lerr = getKey('type',       dType, tr); IF(lerr) RETURN            !--- Tracers types ('tracer' or 'tag')
+  lerr = getKey('name',       tname, tr%keys); IF(lerr) RETURN       !--- Names of the tracers
+  lerr = getKey('gen0Name',   gen0N, tr%keys); IF(lerr) RETURN       !--- Names of the tracers of first generation
+  lerr = getKey('iGeneration', iGen, tr%keys); IF(lerr) RETURN       !--- Generation number
+  lerr = getKey('phases',     phase, tr%keys); IF(lerr) RETURN       !--- Phases names
+  lerr = getKey('parent',   parents, tr%keys); IF(lerr) RETURN       !--- Parents names
+  lerr = getKey('type',       dType, tr%keys); IF(lerr) RETURN       !--- Tracers types ('tracer' or 'tag')
   DO iq = 1, nq                                                      !--- GET THE NUMBER OF TRACERS
     IF(iGen(iq) /= 0) CYCLE                                          !--- Only deal with generation 0 tracers
@@ -726,11 +763,16 @@
         IF(lTag) nam = TRIM(nam)//'_'//TRIM(tname(iq))               !--- <parent>_<name> for tags
         ttr(it) = tr(iq)                                             !--- Same <key>=<val> pairs
-        CALL addKey('name', nam, ttr(it))                            !--- Name with possibly phase suffix
-        CALL addKey('phase', p,  ttr(it))                            !--- Single phase entry
+        ttr(it)%name      = TRIM(nam)                                !--- Name with possibly phase suffix
+        ttr(it)%keys%name = TRIM(nam)                                !--- Name inside the keys decriptor
+        ttr(it)%phase     = p                                        !--- Single phase entry
+        CALL addKey('name', nam, ttr(it)%keys)
+        CALL addKey('phase', p,  ttr(it)%keys)
         IF(lExt) THEN
           parent = parents(iq); IF(iGen(iq) > 0) parent = addPhase(parent, p)
           gen0Nm =   gen0N(iq); IF(iGen(iq) > 0) gen0Nm = addPhase(gen0Nm, p)
-          CALL addKey('parent',   parent, ttr(it))
-          CALL addKey('gen0Name', gen0Nm, ttr(it))
+          ttr(it)%parent   = parent
+          ttr(it)%gen0Name = gen0Nm
+          CALL addKey('parent',   parent, ttr(it)%keys)
+          CALL addKey('gen0Name', gen0Nm, ttr(it)%keys)
         END IF
         it = it+1
@@ -740,5 +782,5 @@
   END DO
   CALL MOVE_ALLOC(FROM=ttr, TO=tr)
-  CALL delKey(['phases'], tr)                                        !--- Remove "phases" key, useless since "phase" is defined
+  CALL delKey(['phases'],tr)                                         !--- Remove few keys entries
 
 END FUNCTION expandPhases
@@ -755,8 +797,9 @@
 !   TO BE ADDED IF NECESSARY: HIGHER MOMENTS AT THE END
 !------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type), INTENT(INOUT) :: tr(:)                            !--- Tracers description vector
-!------------------------------------------------------------------------------------------------------------------------------
-  TYPE(keys_type),       ALLOCATABLE :: tr2(:)
-  INTEGER,               ALLOCATABLE :: iy(:), iz(:), iGen(:)
+  TYPE(trac_type), INTENT(INOUT) :: tr(:)                            !--- Tracer derived type vector
+!------------------------------------------------------------------------------------------------------------------------------
+  TYPE(trac_type),       ALLOCATABLE :: tr2(:)
+  INTEGER,               ALLOCATABLE :: iy(:), iz(:)
+  INTEGER,               ALLOCATABLE ::  iGen(:)
   CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:), gen0N(:)
   INTEGER :: ig, ng, iq, jq, ip, nq, n, ix(SIZE(tr)), k
